<template>
  <div>
    <b-navbar variant="blue" type="light" fixed="top" class="subtle-shadow">
      <div class="navbar-btn" v-on:click="openAppDrawer">
        <svg width="24" height="24" viewBox="0 0 24 24" focusable="false" role="presentation"><path fill="currentColor" fillRule="evenodd" d="M4 5.01C4 4.451 4.443 4 5.01 4h1.98C7.549 4 8 4.443 8 5.01v1.98C8 7.549 7.557 8 6.99 8H5.01C4.451 8 4 7.557 4 6.99V5.01zm0 6c0-.558.443-1.01 1.01-1.01h1.98c.558 0 1.01.443 1.01 1.01v1.98C8 13.549 7.557 14 6.99 14H5.01C4.451 14 4 13.557 4 12.99v-1.98zm6-6c0-.558.443-1.01 1.01-1.01h1.98c.558 0 1.01.443 1.01 1.01v1.98C14 7.549 13.557 8 12.99 8h-1.98C10.451 8 10 7.557 10 6.99V5.01zm0 6c0-.558.443-1.01 1.01-1.01h1.98c.558 0 1.01.443 1.01 1.01v1.98c0 .558-.443 1.01-1.01 1.01h-1.98c-.558 0-1.01-.443-1.01-1.01v-1.98zm6-6c0-.558.443-1.01 1.01-1.01h1.98c.558 0 1.01.443 1.01 1.01v1.98C20 7.549 19.557 8 18.99 8h-1.98C16.451 8 16 7.557 16 6.99V5.01zm0 6c0-.558.443-1.01 1.01-1.01h1.98c.558 0 1.01.443 1.01 1.01v1.98c0 .558-.443 1.01-1.01 1.01h-1.98c-.558 0-1.01-.443-1.01-1.01v-1.98zm-12 6c0-.558.443-1.01 1.01-1.01h1.98c.558 0 1.01.443 1.01 1.01v1.98C8 19.549 7.557 20 6.99 20H5.01C4.451 20 4 19.557 4 18.99v-1.98zm6 0c0-.558.443-1.01 1.01-1.01h1.98c.558 0 1.01.443 1.01 1.01v1.98c0 .558-.443 1.01-1.01 1.01h-1.98c-.558 0-1.01-.443-1.01-1.01v-1.98zm6 0c0-.558.443-1.01 1.01-1.01h1.98c.558 0 1.01.443 1.01 1.01v1.98c0 .558-.443 1.01-1.01 1.01h-1.98c-.558 0-1.01-.443-1.01-1.01v-1.98z"></path></svg>
      </div>

      <b-navbar-brand href="#">
        <!-- <img src="http://placehold.jp//12/4a78e8/4a78e8/30x30.png" class="d-inline-block align-top" alt="Indent"> -->
        <span class="indent">Indent</span> <span class="cloud">{{ title }}</span> 
        <b-badge variant="danger" v-show="is_development">
          Dev
        </b-badge>
        <b-badge variant="warning" v-show="!is_development">
          Alpha
        </b-badge>
      </b-navbar-brand>

      <b-navbar-toggle target="navbar-collapse"></b-navbar-toggle>
      <b-collapse id="navbar-collapse" is-nav>
        <b-navbar-nav class="mr-auto">
          <slot></slot>
        </b-navbar-nav>

        <b-nav-form>
          <b-form-input class="mr-sm-2 subtle-shadow" placeholder="Search"></b-form-input>
        </b-nav-form>

        <div class="navbar-btn">
          <b-icon-bell />
          <div class="notify-badge badge-danger">&nbsp;</div>
        </div>

        <div class="navbar-btn">
          <b-icon-question />
        </div>

        <div class="navbar-btn">
          <b-icon-gear />
        </div>

        <b-navbar-nav>
          <b-nav-item-dropdown id="navbar-user-avatar">
            <template v-slot:button-content>
              <img src="/test_avatar.png" alt="" class="subtle-shadow" />
            </template>
            <b-dropdown-item>
              <strong>
                @{{ user.username }}
              </strong>
            </b-dropdown-item>
            <b-dropdown-divider />
            <b-dropdown-item href="#">My Profile</b-dropdown-item>
            <b-dropdown-item href="#">Account Settings</b-dropdown-item>
            <b-dropdown-divider />
            <b-dropdown-item to="/logout">Logout</b-dropdown-item>
          </b-nav-item-dropdown>
        </b-navbar-nav>
      </b-collapse>
    </b-navbar>
    

    <AppDrawer :show="showAppDrawer" @close="closeAppDrawer" />
  </div>
</template>

<script>
import { mapState } from 'vuex'
import AppDrawer from '@/components/AppDrawer'
import { BIcon, BIconBell, BIconQuestion, BIconGear } from 'bootstrap-vue'

export default {
  name: 'NavigationBar',
  props: {
    title: String
  },
  components: {
    BIcon,
    BIconBell,
    BIconQuestion,
    BIconGear,
    AppDrawer
  },
  data() {
    return {
      showAppDrawer: false,
      is_development: process.env.NODE_ENV === 'development'
    }
  },
  methods: {
    openAppDrawer() {
      this.showAppDrawer = true;
    },
      closeAppDrawer() {
      this.showAppDrawer = false;
    }
  },
  computed: mapState({
    user: state => state.auth.user,
    organization: state => state.organization.info
  })
}
</script>

<style lang="scss">
.bg-blue  {
  background-color: #4a78e8;
}
.navbar-light {
  .navbar-nav {
    .nav-link {
      color: #ffffff !important;

      padding: 4px 8px;
      border-radius: 5px;
      margin: 4px;

      // &.router-link-active {
      //   font-weight: 800;
      //   background: #2c4580;
      // }
    }
  }
}

.navbar {
  .navbar-brand {
    img {
      margin-right: 5px;
      border-radius: 20px;
    }
    .indent {
      color: #ffffff;
      font-weight: 500;
    }
    .cloud {
      color: #e8c24a;
      font-weight: 400;
    }
    .badge {
      margin-left: 5px;
    }
  }

  input[type="text"] {
    background: #ffffff47;
    border: 0;
    color: white;
    transition: all linear 0.1s;
    width: 200px;

    &::placeholder {
      color: white;
    }

    &:focus {
      background: #ffffff8f;
      width: 250px;
    }
  }

  .btn-primary {
    border: 0;
    background-color: #6793ea;

    &:hover {
      background-color: #83a7ef;
    }
  }

  .navbar-btn {
    /* background: #dad9d9; */
    padding: 6px;
    border-radius: 25px;
    width: 36px;
    text-align: center;
    color: #ffffff;
    margin-right: 6px;
    font-size: 22px;
    line-height: 12px;
    position: relative;
    transition: background 180ms linear 0s;

    &:hover {
      background: #ffffff47;
      cursor: pointer;
    }
    .notify-badge {
      position: absolute;
      top: 3px;
      right: 6px;
      font-size: 12px;
      padding: 4px;
      height: 6px;
      width: 6px;
      border-radius: 40px;
    }
  }
  #navbar-user-avatar {
    img {
      border-radius: 25px;
      width: 36px;
      height: 36px;
    }

    & > .nav-link {
      padding: 0;
    }

    & > .dropdown-toggle::after {
      display: none;
    }

    & > .dropdown-menu {
      left: unset;
      right: 0;
    }
  }

  #navbar-user-avatar.dropdown-toggle::after {
    display: none;
  }
  #navbar-user-avatar + .dropdown-menu {
    left: unset;
    right: 0;
  }
}
</style>
